diff --git a/logview/logview.c b/logview/logview.c
index d1bdbaa..91ce390 100644
--- a/logview/logview.c
+++ b/logview/logview.c
@@ -674,47 +801,56 @@ logview_normal_text (GtkAction *action, LogviewWindow *logview)
 static void
 logview_search (GtkAction *action, LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
     
-    gtk_widget_show_all (logview->find_bar);
-    logview_findbar_grab_focus (LOGVIEW_FINDBAR (logview->find_bar));
+	gtk_widget_show_all (logview->find_bar);
+	logview_findbar_grab_focus (LOGVIEW_FINDBAR (logview->find_bar));
 }
 
 static void
 logview_copy (GtkAction *action, LogviewWindow *logview)
 {
 	gchar *text, **lines;
-	int nline, i, l1, l2;
-    gchar *line;
-    Log *log;
-    GtkClipboard *clipboard;
-
-    g_assert (LOGVIEW_IS_WINDOW (logview));
-
-    log = logview->curlog;
-    if (log == NULL)
-        return;
-
-    l1 = log->selected_line_first;
-    l2 = log->selected_line_last;
-    if (l1 == -1 || l2 == -1)
-        return;
-
-    nline = l2 - l1 + 1;
-    lines = g_new0(gchar *, (nline + 1));
-    for (i=0; i<=nline; i++) {
-        line = log->lines[l1+i];
-        lines[i] = g_strdup (line);
-    }
-    lines[nline] = NULL;
-    text = g_strjoinv ("\n", lines);
-
-    clipboard = gtk_widget_get_clipboard (GTK_WIDGET (logview->view),
-                                          GDK_SELECTION_CLIPBOARD);
-    gtk_clipboard_set_text (clipboard, text, -1);
-
-    g_free (text);
-    g_strfreev (lines);
+	int nline, i;
+	gchar *line;
+	GtkTreeIter iter;
+	GtkTreePath *selected_path;
+	Log *log;
+	GtkClipboard *clipboard;
+	GList *selected_paths, *idx;
+	GtkTreeModel *model;
+
+	g_assert (LOGVIEW_IS_WINDOW (logview));
+
+	log = logview->curlog;
+	g_assert (LOGVIEW_IS_LOG (log));
+
+	g_object_get (G_OBJECT (log),
+		      "selected-paths", &selected_paths,
+		      "model", &model,
+		      NULL);
+
+	if (selected_paths == NULL)
+		return;
+
+	nline = g_list_length (selected_paths);
+	lines = g_new0(gchar *, (nline + 1));
+	lines[nline] = NULL;
+	for (i = 0, idx = selected_paths; idx != NULL; idx = g_list_next (idx), i++) {
+		selected_path = idx->data;
+		gtk_tree_model_get_iter (model, &iter, selected_path);
+                gtk_tree_model_get (model,
+				    &iter,
+				    MESSAGE, &lines[i],
+				    -1);
+	}
+	text = g_strjoinv ("\n", lines);
+	clipboard = gtk_widget_get_clipboard (GTK_WIDGET (logview->view),
+					      GDK_SELECTION_CLIPBOARD);
+	gtk_clipboard_set_text (clipboard, text, -1);
+
+	g_free (text);
+	g_strfreev (lines);
 }
 
 static void
@@ -722,7 +858,7 @@ logview_select_all (GtkAction *action, LogviewWindow *logview)
 {
 	GtkTreeSelection *selection;
 
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
 	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (logview->view));
 	gtk_tree_selection_select_all (selection);
@@ -731,12 +867,12 @@ logview_select_all (GtkAction *action, LogviewWindow *logview)
 static void
 logview_menu_item_toggle_set_active (LogviewWindow *logview, char *path, gboolean state)
 {
-    GtkToggleAction *action;
+	GtkToggleAction *action;
     
-    g_assert (path);
+	g_assert (path);
     
-    action = GTK_TOGGLE_ACTION (gtk_ui_manager_get_action (logview->ui_manager, path));
-    gtk_toggle_action_set_active (action, state);
+	action = GTK_TOGGLE_ACTION (gtk_ui_manager_get_action (logview->ui_manager, path));
+	gtk_toggle_action_set_active (action, state);
 }
 
 static void
@@ -753,22 +889,26 @@ logview_menu_item_set_state (LogviewWindow *logview, char *path, gboolean state)
 static void
 logview_calendar_set_state (LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
-
-    if (logview->curlog) {
-        if (logview->curlog->days != NULL)
-            calendar_init_data (CALENDAR (logview->calendar), logview);
-        gtk_widget_set_sensitive (logview->calendar, (logview->curlog->days != NULL));
-    } else
-        gtk_widget_set_sensitive (logview->calendar, FALSE);
+	g_assert (LOGVIEW_IS_WINDOW (logview));
+	gboolean groupable;
+	
+	if (logview->curlog) {
+		g_object_get (G_OBJECT (logview->curlog),
+			      "groupable", &groupable,
+			      NULL);
+		if (groupable)
+			calendar_init_data (CALENDAR (logview->calendar), logview);
+		gtk_widget_set_sensitive (logview->calendar, groupable);
+	} else
+		gtk_widget_set_sensitive (logview->calendar, FALSE);
 }
 
 static void
 logview_help (GtkAction *action, GtkWidget *parent_window)
 {
-    GError *error = NULL;                                                                                
-    gnome_help_display_desktop_on_screen (NULL, "gnome-system-log", "gnome-system-log", NULL,
-                                          gtk_widget_get_screen (GTK_WIDGET(parent_window)), &error);
+	GError *error = NULL;                                                                                
+	gnome_help_display_desktop_on_screen (NULL, "gnome-system-log", "gnome-system-log", NULL,
+					      gtk_widget_get_screen (GTK_WIDGET(parent_window)), &error);
 	if (error) {
 		error_dialog_show (GTK_WIDGET(parent_window), _("There was an error displaying help."), error->message);
 		g_error_free (error);
@@ -777,188 +917,175 @@ logview_help (GtkAction *action, GtkWidget *parent_window)
 
 static gboolean 
 window_size_changed_cb (GtkWidget *widget, GdkEventConfigure *event, 
-				 gpointer data)
+			gpointer data)
 {
-    LogviewWindow *logview = LOGVIEW_WINDOW (data);
+	LogviewWindow *logview = LOGVIEW_WINDOW (data);
     
-    g_assert (LOGVIEW_IS_WINDOW (logview));
-    prefs_store_window_size (GTK_WIDGET(logview));
-    return FALSE;
+	g_assert (LOGVIEW_IS_WINDOW (logview));
+	prefs_store_window_size (GTK_WIDGET(logview));
+	return FALSE;
 }
 
 static void
 logview_window_finalize (GObject *object)
 {
-    LogviewWindow *logview = LOGVIEW_WINDOW(object);
+	LogviewWindow *logview = LOGVIEW_WINDOW(object);
+
+	logview_plugin_list_delete (logview->plugin_list);
 
-    g_object_unref (logview->ui_manager);
-    parent_class->finalize (object);
+	g_object_unref (logview->ui_manager);
+	parent_class->finalize (object);
 }
 
 static void
 logview_init (LogviewWindow *logview)
 {
-   GtkWidget *vbox;
-   GtkTreeStore *tree_store;
-   GtkTreeSelection *selection;
-   GtkTreeViewColumn *column;
-   GtkCellRenderer *renderer;
-   gint i;
-   GtkActionGroup *action_group;
-   GtkAccelGroup *accel_group;
-   GError *error = NULL;
-   GtkWidget *menubar;
-   GtkWidget *hpaned;
-   GtkWidget *label;
-   GtkWidget *main_view;
-   GtkWidget *loglist_scrolled, *scrolled;
-   PangoContext *context;
-   PangoFontDescription *fontdesc;
-   gchar *monospace_font_name;
-
-   gtk_window_set_default_size (GTK_WINDOW (logview), prefs_get_width (), prefs_get_height ());
-
-   vbox = gtk_vbox_new (FALSE, 0);
-   gtk_container_add (GTK_CONTAINER (logview), vbox);
-
-   /* Create menus */
-   action_group = gtk_action_group_new ("LogviewMenuActions");
-   gtk_action_group_set_translation_domain (action_group, NULL);
-   gtk_action_group_add_actions (action_group, entries, G_N_ELEMENTS (entries), logview);
-   gtk_action_group_add_toggle_actions(action_group, toggle_entries, G_N_ELEMENTS (toggle_entries), logview);
-
-   logview->ui_manager = gtk_ui_manager_new ();
-
-   gtk_ui_manager_insert_action_group (logview->ui_manager, action_group, 0);
+	GtkWidget *vbox;
+	GtkTreeSelection *selection;
+	GtkTreeViewColumn *column;
+	GtkCellRenderer *renderer;
+	GtkActionGroup *action_group;
+	GtkAccelGroup *accel_group;
+	GError *error = NULL;
+	GtkWidget *menubar;
+	GtkWidget *hpaned;
+	GtkWidget *label;
+	GtkWidget *main_view;
+	GtkWidget *loglist_scrolled, *scrolled;
+	PangoContext *context;
+	PangoFontDescription *fontdesc;
+	gchar *monospace_font_name;
+
+	gtk_window_set_default_size (GTK_WINDOW (logview), prefs_get_width (), prefs_get_height ());
+
+	vbox = gtk_vbox_new (FALSE, 0);
+	gtk_container_add (GTK_CONTAINER (logview), vbox);
+
+	/* Create menus */
+	action_group = gtk_action_group_new ("LogviewMenuActions");
+	gtk_action_group_set_translation_domain (action_group, NULL);
+	gtk_action_group_add_actions (action_group, entries, G_N_ELEMENTS (entries), logview);
+	gtk_action_group_add_toggle_actions(action_group, toggle_entries, G_N_ELEMENTS (toggle_entries), logview);
+
+	logview->ui_manager = gtk_ui_manager_new ();
+
+	gtk_ui_manager_insert_action_group (logview->ui_manager, action_group, 0);
    
-   accel_group = gtk_ui_manager_get_accel_group (logview->ui_manager);
-   gtk_window_add_accel_group (GTK_WINDOW (logview), accel_group);
+	accel_group = gtk_ui_manager_get_accel_group (logview->ui_manager);
+	gtk_window_add_accel_group (GTK_WINDOW (logview), accel_group);
    
-   if (!gtk_ui_manager_add_ui_from_string (logview->ui_manager, ui_description, -1, &error)) {
-     logview->ui_manager = NULL;
-     return;
-   }
+	if (!gtk_ui_manager_add_ui_from_string (logview->ui_manager, ui_description, -1, &error)) {
+		logview->ui_manager = NULL;
+		return;
+	}
    
-   menubar = gtk_ui_manager_get_widget (logview->ui_manager, "/LogviewMenu");
-   gtk_box_pack_start (GTK_BOX (vbox), menubar, FALSE, FALSE, 0);
+	menubar = gtk_ui_manager_get_widget (logview->ui_manager, "/LogviewMenu");
+	gtk_box_pack_start (GTK_BOX (vbox), menubar, FALSE, FALSE, 0);
 
-   /* panes */
-   hpaned = gtk_hpaned_new ();
-   gtk_box_pack_start (GTK_BOX (vbox), hpaned, TRUE, TRUE, 0);
+	/* panes */
+	hpaned = gtk_hpaned_new ();
+	gtk_box_pack_start (GTK_BOX (vbox), hpaned, TRUE, TRUE, 0);
 
-   /* First pane : sidebar (list of logs + calendar) */
-   logview->sidebar = gtk_vbox_new (FALSE, 0);
-   
-   logview->calendar = calendar_new ();
-   calendar_connect (CALENDAR (logview->calendar), logview);
-   gtk_box_pack_end (GTK_BOX (logview->sidebar), GTK_WIDGET(logview->calendar), FALSE, FALSE, 0);
+	/* First pane : sidebar (list of logs + calendar) */
+	logview->sidebar = gtk_vbox_new (FALSE, 0);
    
-   /* log list */
-   loglist_scrolled = gtk_scrolled_window_new (NULL, NULL);
-   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (loglist_scrolled),
-                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
-   gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (loglist_scrolled),
-                                        GTK_SHADOW_ETCHED_IN);
-   logview->loglist = loglist_new ();
-   gtk_container_add (GTK_CONTAINER (loglist_scrolled), logview->loglist);
-   gtk_box_pack_start (GTK_BOX (logview->sidebar), loglist_scrolled, TRUE, TRUE, 0);
-   gtk_paned_pack1 (GTK_PANED (hpaned), logview->sidebar, FALSE, FALSE);
-   loglist_connect (LOG_LIST(logview->loglist), logview);
-
-   /* Second pane : log */
-   main_view = gtk_vbox_new (FALSE, 0);
-   gtk_paned_pack2 (GTK_PANED (hpaned), GTK_WIDGET (main_view), TRUE, TRUE);
-
-   /* Scrolled window for the main view */
-   scrolled = gtk_scrolled_window_new (NULL, NULL);
-   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled),
-               GTK_POLICY_AUTOMATIC,
-               GTK_POLICY_AUTOMATIC);
-   gtk_box_pack_start (GTK_BOX(main_view), scrolled, TRUE, TRUE, 0);
-
-   /* Main Tree View */
-   logview->view = gtk_tree_view_new ();
-   gtk_tree_view_set_fixed_height_mode (GTK_TREE_VIEW (logview->view), FALSE);
-   gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (logview->view), FALSE);
-
-   /* Use the desktop monospace font */
-   monospace_font_name = prefs_get_monospace ();
-   logview_set_font (logview, monospace_font_name);
-   g_free (monospace_font_name);
-
-   renderer = gtk_cell_renderer_text_new ();
-   column = gtk_tree_view_column_new ();
-   gtk_tree_view_column_pack_start (column, renderer, TRUE);
-   gtk_tree_view_column_set_attributes (column, renderer, 
-                                        "text", LOG_LINE_TEXT, 
-                                        "weight", LOG_LINE_WEIGHT,
-                                        "weight-set", LOG_LINE_WEIGHT_SET,
-                                        NULL);
-   //gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_FIXED);
-   gtk_tree_view_append_column (GTK_TREE_VIEW (logview->view), column);
-
-   /* Version selector */
-   logview->version_bar = gtk_hbox_new (FALSE, 0);
-   gtk_container_set_border_width (GTK_CONTAINER (logview->version_bar), 3);
-   logview->version_selector = gtk_combo_box_new_text ();
-   g_signal_connect (G_OBJECT (logview->version_selector), "changed",
-                     G_CALLBACK (logview_version_selector_changed), logview);
-   label = gtk_label_new (_("Version: "));
+	logview->calendar = calendar_new ();
+	calendar_connect (CALENDAR (logview->calendar), logview);
+	gtk_box_pack_end (GTK_BOX (logview->sidebar), GTK_WIDGET(logview->calendar), FALSE, FALSE, 0);
    
-   gtk_box_pack_end (GTK_BOX(logview->version_bar), logview->version_selector, FALSE, FALSE, 0);
-   gtk_box_pack_end (GTK_BOX(logview->version_bar), label, FALSE, FALSE, 0);
-   gtk_box_pack_end (GTK_BOX(main_view), logview->version_bar, FALSE, FALSE, 0);
+	/* log list */
+	loglist_scrolled = gtk_scrolled_window_new (NULL, NULL);
+	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (loglist_scrolled),
+					GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
+	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (loglist_scrolled),
+					     GTK_SHADOW_ETCHED_IN);
+	logview->loglist = loglist_new ((gpointer)logview);
+	gtk_container_add (GTK_CONTAINER (loglist_scrolled), logview->loglist);
+	gtk_box_pack_start (GTK_BOX (logview->sidebar), loglist_scrolled, TRUE, TRUE, 0);
+	gtk_paned_pack1 (GTK_PANED (hpaned), logview->sidebar, FALSE, FALSE);
+
+	/* Second pane : log */
+	main_view = gtk_vbox_new (FALSE, 0);
+	gtk_paned_pack2 (GTK_PANED (hpaned), GTK_WIDGET (main_view), TRUE, TRUE);
+
+	/* Scrolled window for the main view */
+	scrolled = gtk_scrolled_window_new (NULL, NULL);
+	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled),
+					GTK_POLICY_AUTOMATIC,
+					GTK_POLICY_AUTOMATIC);
+	gtk_box_pack_start (GTK_BOX(main_view), scrolled, TRUE, TRUE, 0);
+
+	/* Main Tree View */
+	logview->view = gtk_tree_view_new ();
+	gtk_tree_view_set_fixed_height_mode (GTK_TREE_VIEW (logview->view), FALSE);
+	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (logview->view), FALSE);
+
+	/* Use the desktop monospace font */
+	monospace_font_name = prefs_get_monospace ();
+	logview_set_font (logview, monospace_font_name);
+	g_free (monospace_font_name);
+
+	renderer = gtk_cell_renderer_text_new ();
+	column = gtk_tree_view_column_new ();
+	gtk_tree_view_column_pack_start (column, renderer, TRUE);
+	gtk_tree_view_column_set_attributes (column, renderer, 
+					     "text", LOG_LINE_TEXT, 
+					     "weight", LOG_LINE_WEIGHT1,
+					     "weight-set", LOG_LINE_WEIGHT_SET1,
+					     NULL);
+	gtk_tree_view_append_column (GTK_TREE_VIEW (logview->view), column);
+
+	/* Version selector */
+	logview->version_bar = gtk_hbox_new (FALSE, 0);
+	gtk_container_set_border_width (GTK_CONTAINER (logview->version_bar), 3);
+	logview->version_selector = gtk_combo_box_new_text ();
+	g_signal_connect (G_OBJECT (logview->version_selector), "changed",
+			  G_CALLBACK (logview_version_selector_changed), logview);
+	label = gtk_label_new (_("Version: "));
    
-   logview->find_bar = logview_findbar_new ();
-   gtk_box_pack_end (GTK_BOX (main_view), logview->find_bar, FALSE, FALSE, 0);
-   logview_findbar_connect (LOGVIEW_FINDBAR (logview->find_bar), logview);
-
-   /* Remember the original font size */
-   context = gtk_widget_get_pango_context (logview->view);
-   fontdesc = pango_context_get_font_description (context);
-   logview->original_fontsize = pango_font_description_get_size (fontdesc) / PANGO_SCALE;
-   logview->fontsize = logview->original_fontsize;
-
-   gtk_container_add (GTK_CONTAINER (scrolled), GTK_WIDGET (logview->view));
-   gtk_widget_show_all (scrolled);
+	gtk_box_pack_end (GTK_BOX(logview->version_bar), logview->version_selector, FALSE, FALSE, 0);
+	gtk_box_pack_end (GTK_BOX(logview->version_bar), label, FALSE, FALSE, 0);
+	gtk_box_pack_end (GTK_BOX(main_view), logview->version_bar, FALSE, FALSE, 0);
    
-   selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (logview->view));
-   gtk_tree_selection_set_mode (selection, GTK_SELECTION_MULTIPLE);
-
-   /* Add signal handlers */
-   g_signal_connect (G_OBJECT (selection), "changed",
-                     G_CALLBACK (selection_changed_cb), logview);
-   g_signal_connect (G_OBJECT (logview->view), "row-expanded",
-                     G_CALLBACK (row_toggled_cb), logview);
-   g_signal_connect (G_OBJECT (logview->view), "row-collapsed",
-                     G_CALLBACK (row_toggled_cb), logview);
-   g_signal_connect (G_OBJECT (logview), "configure_event",
-                     G_CALLBACK (window_size_changed_cb), logview);
-
-   /* Status area at bottom */
-   logview->statusbar = gtk_statusbar_new ();
-   gtk_box_pack_start (GTK_BOX (vbox), logview->statusbar, FALSE, FALSE, 0);
-
-   gtk_widget_show (menubar);
-   gtk_widget_show (loglist_scrolled);
-   gtk_widget_show (main_view);
-   gtk_widget_show (vbox);
-   logview->hpaned = hpaned;
-}
+	logview->find_bar = logview_findbar_new ();
+	gtk_box_pack_end (GTK_BOX (main_view), logview->find_bar, FALSE, FALSE, 0);
+	logview_findbar_connect (LOGVIEW_FINDBAR (logview->find_bar), logview);
 
-static void
-logview_window_get_property (GObject *object, guint param_id, GValue *value, GParamSpec *pspec)
-{
-  LogviewWindow *logview = LOGVIEW_WINDOW (object);
-  
-  switch (param_id) {
-  case PROP_DAYS:
-    g_value_set_pointer (value, logview->curlog->days);
-    break;
-  default:
-    G_OBJECT_WARN_INVALID_PROPERTY_ID (object, param_id, pspec);
-    break;
-  }
+	/* Remember the original font size */
+	context = gtk_widget_get_pango_context (logview->view);
+	fontdesc = pango_context_get_font_description (context);
+	logview->original_fontsize = pango_font_description_get_size (fontdesc) / PANGO_SCALE;
+	logview->fontsize = logview->original_fontsize;
+
+	gtk_container_add (GTK_CONTAINER (scrolled), GTK_WIDGET (logview->view));
+	gtk_widget_show_all (scrolled);
+   
+	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (logview->view));
+	gtk_tree_selection_set_mode (selection, GTK_SELECTION_MULTIPLE);
+
+	/* Add signal handlers */
+	g_signal_connect (G_OBJECT (selection), "changed",
+			  G_CALLBACK (selection_changed_cb), logview);
+	g_signal_connect (G_OBJECT (logview->view), "row-expanded",
+			  G_CALLBACK (row_toggled_cb), logview);
+	g_signal_connect (G_OBJECT (logview->view), "row-collapsed",
+			  G_CALLBACK (row_toggled_cb), logview);
+	g_signal_connect (G_OBJECT (logview), "configure_event",
+			  G_CALLBACK (window_size_changed_cb), logview);
+
+	/* Status area at bottom */
+	logview->statusbar = gtk_statusbar_new ();
+	gtk_box_pack_start (GTK_BOX (vbox), logview->statusbar, FALSE, FALSE, 0);
+
+	gtk_widget_show (menubar);
+	gtk_widget_show (loglist_scrolled);
+	gtk_widget_show (main_view);
+	gtk_widget_show (vbox);
+	logview->hpaned = hpaned;
+	logview->plugin_list = logview_plugin_list_new ();
+
+	/* set logview pointer */
+	monitor_set_window ((gpointer)logview);
 }
 
 static void
@@ -967,14 +1094,7 @@ logview_window_class_init (LogviewWindowClass *klass)
 	GObjectClass *object_class = (GObjectClass *) klass;
 
 	object_class->finalize = logview_window_finalize;
-	object_class->get_property = logview_window_get_property;
 	parent_class = g_type_class_peek_parent (klass);
-
-	g_object_class_install_property (object_class, PROP_DAYS,
-					 g_param_spec_pointer ("days",
-					 _("Days"),
-					 _("Pointer towards a GSList of days for the current log."),
-					 (G_PARAM_READABLE)));
 }
 
 GType
@@ -1004,21 +1124,28 @@ logview_window_get_type (void)
 GtkWidget *
 logview_window_new ()
 {
-   LogviewWindow *logview;
-   GtkWidget *window;
+	LogviewWindow *logview;
+	GtkWidget *window;
 
-   window = g_object_new (LOGVIEW_TYPE_WINDOW, NULL);
-   logview = LOGVIEW_WINDOW (window);
-   if (logview->ui_manager == NULL)
-     return NULL;
+	window = g_object_new (LOGVIEW_TYPE_WINDOW, NULL);
+	logview = LOGVIEW_WINDOW (window);
+	if (logview->ui_manager == NULL)
+		return NULL;
 
-   logview->logs = NULL;
+	logview->logs = NULL;
 
-   gtk_ui_manager_set_add_tearoffs (logview->ui_manager, 
-                                    prefs_get_have_tearoff ());
+	gtk_ui_manager_set_add_tearoffs (logview->ui_manager, 
+					 prefs_get_have_tearoff ());
 
-   g_signal_connect (GTK_OBJECT (window), "destroy",
-                     G_CALLBACK (logview_destroy), logview);
+	g_signal_connect (GTK_OBJECT (window), "destroy",
+			  G_CALLBACK (logview_destroy), logview);
 
-   return window;
+	return window;
+}
+
+static void
+logview_plugin_dialog_show (GtkAction *action, LogviewWindow *logview)
+{
+	g_assert (LOGVIEW_IS_WINDOW (logview));
+	logview_plugin_list_show (logview->plugin_list, GTK_WIDGET (logview));
 }
diff --git a/logview/logview.h b/logview/logview.h
index dacfa2e..1e826d6 100644
--- a/logview/logview.h
+++ b/logview/logview.h
@@ -23,6 +23,7 @@
 #define __LOGVIEW_H__
 
 #include "logrtns.h"
+#include "logview-plugin-list.h"
 
 #define MAX_VERSIONS             5
 
@@ -39,19 +40,20 @@ typedef struct _LogviewWindowClass LogviewWindowClass;
 struct _LogviewWindow {
 	GtkWindow parent_instance;
 
-	GtkWidget *view;		
+	GtkWidget *view;
 	GtkWidget *statusbar;
 	GtkUIManager *ui_manager;
 
 	GtkWidget *calendar;
 	GtkWidget *find_bar;
 	GtkWidget *loglist;
-	GtkWidget *sidebar; 
+	GtkWidget *sidebar;
 	GtkWidget *version_bar;
 	GtkWidget *version_selector;
-        GtkWidget *hpaned;
-    
-        GSList *logs;
+	GtkWidget *hpaned;
+	LogviewPluginList *plugin_list;
+	
+	GSList *logs;
 	Log *curlog;
 
 	int original_fontsize, fontsize;
diff --git a/logview/main.c b/logview/main.c
index 37242b8..05e17af 100644
--- a/logview/main.c
+++ b/logview/main.c
@@ -36,6 +36,8 @@
 #include "logview.h"
 #include "misc.h"
 #include "userprefs.h"
+#include "logview-plugin-manager.h"
+#include "logview-debug.h"
 
 static gboolean show_version = FALSE;
 
@@ -86,7 +88,6 @@ save_session_cb (GnomeClient        *gnome_client,
 	gchar **argv;
 	gint numlogs;
 	GSList *logs;
-	Log *log;
 	gint i = 0;
 
 	g_assert (LOGVIEW_IS_WINDOW (logview));
@@ -98,12 +99,11 @@ save_session_cb (GnomeClient        *gnome_client,
 	argv = g_new0 (gchar *, numlogs + 2);
 	argv[i++] = g_get_prgname();
 
-	for (logs = logview->logs; logs != NULL; logs = logs->next) {
+	for (i = 1, logs = logview->logs; logs != NULL; logs = logs->next) {
 		Log *log = (Log *) logs->data;
 
 		g_assert (log != NULL);
-
-		argv[i++] = g_strdup (log->name);
+		g_object_get (G_OBJECT (log), "path", &argv[i++], NULL);
 	}
 	
         argv[i] = NULL;
@@ -120,7 +120,6 @@ int
 main (int argc, char *argv[])
 {
 	GnomeClient *gnome_client;
-	GError *error;
 	GnomeProgram *program;
 	GOptionContext *context;
 	LogviewWindow *logview;
@@ -129,10 +128,6 @@ main (int argc, char *argv[])
 	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
 	textdomain (GETTEXT_PACKAGE);
 
-	error_dialog_queue (TRUE);
-	
-	gnome_vfs_init ();
-	prefs_init ();
 	context = logview_init_options ();
 	
 	program = gnome_program_init ("gnome-system-log", VERSION,
@@ -140,20 +135,42 @@ main (int argc, char *argv[])
 				      argc, argv,
 				      GNOME_PARAM_APP_DATADIR, DATADIR,
 				      GNOME_PARAM_GOPTION_CONTEXT, context,
-				      NULL);
+				      GNOME_PARAM_NONE);
 	
 	g_set_application_name (_("Log Viewer"));
 
 	if (show_version)
 		logview_show_version_and_quit ();
-	
+
+	error_dialog_queue (TRUE);
+
+	g_type_init ();
+	if (! g_thread_supported ())
+		g_thread_init (NULL);
+
+	if (!create_home_dir ()) {
+		g_printf (_("Fatal error! Can't open $HOME/%s.\n"),
+			  LOGVIEW_HOME_SUFFIX);
+		exit (1);
+	}
+
+	gnome_vfs_init ();
+	logview_debug_init ();
+	pluginmgr_init ();
+	if (!pluginmgr_load_modules ()) {
+		error_dialog_show (NULL,
+				   _("Unable to load modules."),
+				   NULL);
+		exit (1);
+	}
+	prefs_init ();
+
 	/* Open regular logs and add each log passed as a parameter */
 	logview = LOGVIEW_WINDOW (logview_window_new ());
 	if (!logview) {
 		error_dialog_show (NULL,
 				   _("Unable to create user interface."),
 				   NULL);
-		
 		exit (0);
 	}
 
@@ -174,7 +191,7 @@ main (int argc, char *argv[])
 	} else {
 		gint i;
 		
-		for (i = 1; i < argc; i++)
+ 		for (i = 1; i < argc; i++) 
 			logview_add_log_from_name (logview, argv[i]);
 	}
 
@@ -191,6 +208,10 @@ main (int argc, char *argv[])
 	}
 
 	gtk_main ();
-   
+
+	pluginmgr_destroy ();
+	logview_debug_destroy ();
+	gnome_vfs_shutdown ();
 	return EXIT_SUCCESS;
 }
+
